unit uMain;

interface

uses
  Windows,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  xmldom,
  XMLIntf,
  msxmldom,
  XMLDoc,
  DateUtils,
  ExtCtrls,
  Buttons,
  Types;

type
  TfrmMain = class(TForm)
    Label26: TLabel;
    pnlInfo: TPanel;
    edUserName: TEdit;
    edPassword: TEdit;
    edSenderNumber: TEdit;
    lblUserName: TLabel;
    lblSenderNumber: TLabel;
    lblPassword: TLabel;
    lbxToNumbers: TListBox;
    btnAddNumber: TSpeedButton;
    btnDeleteNumber: TSpeedButton;
    lblToNumbers: TLabel;
    memMessage: TMemo;
    lblMessage: TLabel;
    chkFlash: TCheckBox;
    pnlActions: TPanel;
    btnSendSMS: TBitBtn;
    btnGetCredit: TBitBtn;
    btnGetDelivery: TBitBtn;
    btnGetInboxCount: TBitBtn;
    btnGetMessages: TBitBtn;
    memResult: TMemo;
    edSmsId: TEdit;
    lblSmsId: TLabel;
    Label1: TLabel;
    function GetDeliveryStateText(DeliveryStatus: Integer): string;
    procedure btnSendSMSClick(Sender: TObject);
    procedure btnGetCreditClick(Sender: TObject);
    procedure btnGetDeliveryClick(Sender: TObject);
    procedure btnGetInboxCountClick(Sender: TObject);
    procedure btnGetMessagesClick(Sender: TObject);
    procedure btnAddNumberClick(Sender: TObject);
    procedure btnDeleteNumberClick(Sender: TObject);
  private
    { Private declarations }
    function GetMessageStatusText(StatusCode: Integer): string;
    function TranslateGetDeliveryResult(DeliveryStatus: Integer): string;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses uSmsUtils;

{$R *.dfm}

function TfrmMain.GetMessageStatusText(StatusCode: Integer): string;
begin
  Result := '';
  if StatusCode < 100 then
  begin
    case StatusCode of
      -1: Result := '     ';
      0: Result := '    ';
      1: Result := '       ';
      2: Result := '   ';
      3: Result := '           ';
      4: Result := '   ';
      5: Result := ' ϐ ǘ 100   ';
      6: Result := '   ';
      7: Result := '      ';
      8: Result := '  ';
      9: Result := '     ';
      10: Result := '   ';
      11: Result := '   ';
    end
  end;
end;

function TfrmMain.TranslateGetDeliveryResult(DeliveryStatus: Integer): string;
begin
  Result := '';
  case DeliveryStatus of
    -5: Result := '           ';
    -4: Result := '         ϡ      ';
    -3: Result := '           ʡ       ';
    -2: Result := '      (SmsId  )';
    -1: Result := '     ';
    0: Result := '    ';
  end;
end;

function TfrmMain.GetDeliveryStateText(DeliveryStatus: Integer): string;
begin
  Result := '';
  case DeliveryStatus of
    -1: Result := '     ';
    0: Result := '   ';
    1: Result := '  ';
    2: Result := '  ';
    3: Result := ' ';
    4: Result := ' ';
    5: Result := '  ';
    6: Result := '  ';
    7: Result := '   ';
    8: Result := '';
    9: Result := '     ';
    10: Result := '   ǁ';
  end;
end;

procedure TfrmMain.btnSendSMSClick(Sender: TObject);
var
  arToNumbers: ArrayOfString;
  I, StatusCode, SmsId: Integer;
  sMessage: string;
begin
  if Trim(edUserName.Text) = '' then
  begin
    edUserName.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(edPassword.Text) = '' then
  begin
    edPassword.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(edSenderNumber.Text) = '' then
  begin
    edSenderNumber.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(memMessage.Text) = '' then
  begin
    memMessage.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(lbxToNumbers.Items.Text) = '' then
  begin
    lbxToNumbers.SetFocus;
    ShowMessage('ϐ   ');
    Exit;
  end;

  memResult.Clear;
  SetLength(arToNumbers, lbxToNumbers.Count);
  for I := 0 to lbxToNumbers.Count - 1 do
    arToNumbers[I] := lbxToNumbers.Items[I];
  StatusCode := TSendSmsWS.SendSms(edUserName.Text, edPassword.Text, arToNumbers, edSenderNumber.Text, memMessage.Text, chkFlash.Checked, SmsId);

  sMessage := GetMessageStatusText(StatusCode);
  if StatusCode = 0 then
    sMessage := sMessage + #13#10 + 'SmsId = ' + IntToStr(SmsId);
  memResult.Text := sMessage;
end;

procedure TfrmMain.btnGetCreditClick(Sender: TObject);
var
  Credit: Double;
begin
  if Trim(edUserName.Text) = '' then
  begin
    edUserName.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(edPassword.Text) = '' then
  begin
    edPassword.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  memResult.Clear;
  Credit := TSendSmsWS.GetCredit(edUserName.Text, edPassword.Text);
  if Credit = -1 then
    memResult.Text := '       '
  else if Credit = -2 then
    memResult.Text := '    '
  else
    memResult.Text := '  : ' + FloatToStr(Credit) + ' ';
end;

procedure TfrmMain.btnGetDeliveryClick(Sender: TObject);
var
  I, RetCode: Integer;
  Numbers: ArrayOfString;
  DeliveryStatus: ArrayOfInteger;
  Msg: string;
begin
  if Trim(edUserName.Text) = '' then
  begin
    edUserName.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(edPassword.Text) = '' then
  begin
    edPassword.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(edSmsId.Text) = '' then
  begin
    edSmsId.SetFocus;
    ShowMessage('   SmsId');
    Exit;
  end;

  memResult.Clear;
  RetCode := TSendSmsWS.GetDelivery(edUserName.Text, edPassword.Text, StrToInt(edSmsId.Text), Numbers, DeliveryStatus, 1, 10);
  memResult.Lines.Add(TranslateGetDeliveryResult(RetCode));
  memResult.Lines.Add('----------------------------------');
  if RetCode = 0 then
  begin
    Msg := '';
    for I := 0 to High(DeliveryStatus) do
      Msg := Msg + ' = ' + Numbers[I] + ',  = ' + GetDeliveryStateText(DeliveryStatus[I]) + #13#10;
    memResult.Lines.Add(Msg)
  end;
end;

procedure TfrmMain.btnGetInboxCountClick(Sender: TObject);
var
  Count: integer;
begin
  if Trim(edUserName.Text) = '' then
  begin
    edUserName.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(edPassword.Text) = '' then
  begin
    edPassword.SetFocus;
    ShowMessage('    ');
    Exit;
  end;
  memResult.Clear;
  Count := TSendSmsWS.GetInboxCount(edUserName.Text, edPassword.Text, true);

  if Count = -1 then
    memResult.Text := '       '
  else
    memResult.Text := IntToStr(Count);
end;

procedure TfrmMain.btnGetMessagesClick(Sender: TObject);
var
  status, status_message: string;
  messages: ArrayOfMessageInfoRec;
  I: Integer;
  slMessageInfo: TStringList;
begin
  if Trim(edUserName.Text) = '' then
  begin
    edUserName.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(edPassword.Text) = '' then
  begin
    edPassword.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  if Trim(edSenderNumber.Text) = '' then
  begin
    edSenderNumber.SetFocus;
    ShowMessage('    ');
    Exit;
  end;

  memResult.Clear;
  slMessageInfo := TStringList.Create;
  try
    messages := TSendSmsWS.GetMessages(edUserName.Text, edPassword.Text, 2, varArrayOf([edSenderNumber.Text]), 1, 10);
    for I := 0 to Length(messages) - 1 do
    begin
      slMessageInfo.Clear;
      slMessageInfo.Add('--------------------(' + IntToStr(I + 1) + ')--------------------');
      slMessageInfo.Add('MessageId = ' + IntToStr(messages[I].MessageId));
      slMessageInfo.Add('UserId = ' + IntToStr(messages[I].UserId));
      slMessageInfo.Add('Tariff = ' + FloatToStr(messages[I].Tariff));
      slMessageInfo.Add('MessageType = ' + IntToStr(messages[I].MessageType));
      slMessageInfo.Add('Content = ' + messages[I].Content);
      slMessageInfo.Add('ActionDateTime = ' + DateTimeToStr(messages[i].ActionDateTime));
      slMessageInfo.Add('MessageType = ' + IntToStr(messages[I].MessageType));
      slMessageInfo.Add('Sender = ' + messages[I].Sender);
      slMessageInfo.Add('Receiver = ' + messages[I].Receiver);
      slMessageInfo.Add('Flash = ' + BoolToStr(messages[i].IsFlash));
      slMessageInfo.Add('Pages = ' + IntToStr(messages[I].Pages));
      slMessageInfo.Add('Lang = ' + IntToStr(messages[I].SmsLang));
      slMessageInfo.Add('Status = ' + IntToStr(messages[I].SmsStatus));
      slMessageInfo.Add('Title = ' + messages[I].Title);
      slMessageInfo.Add('Count = ' + IntToStr(messages[I].Count));
      slMessageInfo.Add('Sent = ' + IntToStr(messages[I].Sent));
      slMessageInfo.Add('Description = ' + messages[I].Description);
      slMessageInfo.Add('NotSent = ' + IntToStr(messages[I].NotSent));
      slMessageInfo.Add('MoneyIsRefunded = ' + BoolToStr(messages[I].MoneyIsRefunded));
      slMessageInfo.Add('IsRead = ' + BoolToStr(messages[I].IsRead));
      memResult.Lines.Add(slMessageInfo.Text);
    end;
  finally
    slMessageInfo.Free;
  end;
end;

procedure TfrmMain.btnAddNumberClick(Sender: TObject);
var
  sNumber: string;
begin
  sNumber := InputBox('   ', ' ', '');
  if sNumber <> '' then
    lbxToNumbers.Items.Add(sNumber);
end;

procedure TfrmMain.btnDeleteNumberClick(Sender: TObject);
begin
  if lbxToNumbers.ItemIndex <> -1 then
    lbxToNumbers.Items.Delete(lbxToNumbers.ItemIndex);
end;

end.

